package Storage::PostgresqlDbBundle;

use strict;
use Storage::DbBundle;
use vars qw|@ISA|;

@ISA = qw|Storage::DbBundle|;

sub run {
	my ($self) = @_;
	my %params = %{$self->{params}};
	my $dbname = $params{'name'};
	my $user = $params{'user'};

	$params{'name'} = 'template1';

	my $connection = Db::Connection::getConnection(%params);
	my $exist = $connection->execute_rownum("SELECT * FROM pg_group WHERE groname = '$dbname' AND (SELECT usesysid FROM pg_user WHERE usename = '$user') = ANY (grolist)");

	$connection->finish();

	if (!defined $exist || $exist < 1) { # user does not exist in group
		$exist = $connection->execute_rownum("SELECT * FROM pg_group WHERE groname = '$dbname'");
		$connection->finish();

		if (!defined $exist || $exist < 1) { # group does not exist
			$self->{'params'}->{'group_created'} = $connection->execute_rownum("CREATE GROUP \"$dbname\" WITH USER \"$user\"");
		}
		else {
			$connection->execute_rownum("ALTER GROUP \"$dbname\" ADD USER \"$user\"");
		}

		$connection->finish();
		$self->{'params'}->{'connection'} = $connection;
	}
	else {
		$connection->disconnect();
	}

	if (defined $params{'pg_manage'}) {
		my $cmd = $params{'pg_manage'}.' add_db_usr '.$self->{'params'}->{'name'}.' '.$params{'user'};
		$cmd = `$cmd`;
	}

	return $self->SUPER::run();
}

sub cleanup {
	my ($self) = @_;
	my %params = %{$self->{params}};

	$self->SUPER::cleanup();

	if (defined $params{'connection'}) {
		my $connection = $params{'connection'};

		if (defined $params{'group_created'}) {
			$connection->execute_rownum('DROP GROUP "'.$params{'name'}.'"');
		}
		else {
			$connection->execute_rownum('ALTER GROUP "'.$params{'name'}.'" DROP USER "'.$params{'user'}.'"');
		}

		$connection->finish();
		$connection->disconnect();
	}

	if (defined $params{'pg_manage'}) {
		my $cmd = $params{'pg_manage'}.' rm_db_usr '.$params{'name'}.' '.$params{'user'};
		$cmd = `$cmd`;
	}

}
